package cn.estsh.i3plus.pojo.wms.repository;

import cn.estsh.i3plus.pojo.base.jpa.dao.BaseRepository;
import cn.estsh.i3plus.pojo.wms.bean.WmsStockSn;
import org.springframework.data.jpa.repository.Query;

/**
* @Description : 库存条码dao层
* @Reference :
* @Author : dragon.xu
* @CreateDate : 2018-11-17 15:53
* @Modify:
**/
public interface WmsStockSnRepository extends BaseRepository<WmsStockSn, Long> {
    /**
     * 按照条码查询实体
     * @param sn 条码
     * @return 库存条码实体
     */
    WmsStockSn findFirstBySn(String sn);


    /**
     * 按照存储区代码查询最早批次的物料条码
     * 按照 特殊批次、生产日期、收货日期 优先级从高到低依次排序
     * @return 最早批次的条码
     */
    @Query(value = "select sn from WmsStockSn " +
            "where organizeCode=?1 and isValid=?2 and isDeleted=?3 " +
            "and zoneNo=?4 and partNo=?5 " +
            "order by fixLotNo, dateCode, lotNo")
    WmsStockSn findFirstFifoSNByZoneNo(String organizeCode, int isValid, int isDeleted, String zoneNo, String partNo);
}
